package
{
	import de.popforge.ui.Slider;
	import de.popforge.ui.SliderAlign;
	
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	import flash.geom.Rectangle;
	
	[SWF( backgroundColor='0xfafafa', frameRate='500', width='512', height='512')]

	public class Main extends Sprite
	{
		[Embed(source='assets/image.jpg')] public var TContent: Class;

		private var frame: Sprite;
		private var bitmap: Bitmap;
		
		private var sliderH: Slider;
		private var sliderV: Slider;
		
		private var visibleArea: Rectangle;
		
		public function Main()
		{
			visibleArea = new Rectangle( 0, 0, 256, 256 );
			
			bitmap = Bitmap( new TContent() );
			
			frame = new Sprite();
			frame.x = 128;
			frame.y = 128;
			frame.addChild( bitmap );
			frame.scrollRect = visibleArea;
			addChild( frame );

			sliderH = new Slider( visibleArea.width, 16, SliderAlign.HORIZONTAL );
			sliderH.x = 128;
			sliderH.y = 128 + visibleArea.height + 2;
			sliderH.onChanged = onHSliderChanged;
			sliderH.setKnobSize( visibleArea.width / bitmap.width );
			addChild( sliderH );

			sliderV = new Slider( visibleArea.width, 16, SliderAlign.VERTICAL );
			sliderV.x = 128 + visibleArea.width + 2;
			sliderV.y = 128;
			sliderV.onChanged = onVSliderChanged;
			sliderV.setKnobSize( visibleArea.height / bitmap.height );
			addChild( sliderV );

			//-- SCALE BITMAP
			var slider: Slider = new Slider( visibleArea.width, 16, SliderAlign.HORIZONTAL );
			slider.x = 128;
			slider.y = 92;
			slider.onChanged = onZSliderChanged;
			addChild( slider );
			slider.setValue( 1 );
			
			sliderV.setValue( .5 );
			sliderH.setValue( .5 );
		}
		
		private function onHSliderChanged( slider: Slider ): void
		{
			var value: Number = slider.getValue();
			
			bitmap.x = -( bitmap.width - visibleArea.width ) * value;
		}
		
		private function onVSliderChanged( slider: Slider ): void
		{
			var value: Number = slider.getValue();
			
			bitmap.y = -( bitmap.height - visibleArea.height ) * value;
		}
		
		private function onZSliderChanged( slider: Slider ): void
		{
			var value: Number = slider.getValue();
			
			bitmap.scaleX =
			bitmap.scaleY = value;
			
			sliderH.setKnobSize( visibleArea.width / bitmap.width );
			sliderV.setKnobSize( visibleArea.height / bitmap.height );
		}
	}
}
